unit uEditarFichaGTer_combinado;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
  {$IFDEF WINDOWS}
  Windows,
  {$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, uBaseEditoresFichas,
  uGTer_combinado, uCosaConNombre, uFichasLPD, StdCtrls, Grids, utilidades, uFechas,
  ExtCtrls, uconstantesSimSEE, uBaseEditoresFichasGeneradores,
  usalasdejuego,
  uSalasDeJuegoParaEditor,
  xMatDefs, uverdoc, uFuentesAleatorias, uOpcionesSimSEEEdit;

resourcestring
  rsPotenciaMinima = 'Potencia mínima[MW]';
  rsPotenciaMaxima = 'Potencia maxima[MW]';
  rsCostoVariablePotenciaMinima = 'Costo variable a potencia mínima[USD/MWh]';
  rsCostoVariable = 'Costo variable[USD/MWh]';
  rsCoeficienteDisponibilidadFortuita = 'Coeficiente de disponibildad fortuita[p.u.]';
  rsTiempoDeReparacionH = 'Tiempo de reparación[horas]';

type

  { TEditarFichaGTer_combinado }

  TEditarFichaGTer_combinado = class(TBaseEditoresFichasGeneradores)
    ePagoPorEnergia: TEdit;
    ePagoPorPotencia: TEdit;
    EPotTVdivTG: TEdit;
    EFIni: TEdit;
    GroupBox1: TGroupBox;
    IntFichaTG: TStringGrid;
    IntFichaTV: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    LTGdivTG: TLabel;
    LFactorPotenciaCC: TLabel;
    LabelCC: TLabel;
    LabelTV: TLabel;
    LabelTG: TLabel;
    LFIni: TLabel;
    BGuardar: TButton;
    BCancelarFicha: TButton;
    CBPeriodicidad: TCheckBox;
    PPeriodicidad: TPanel;
    LFinPeriodo: TLabel;
    LIniPeriodo: TLabel;
    LLargoPeriodo: TLabel;
    EFFinPeriodo: TEdit;
    EFIniPeriodo: TEdit;
    sgPeriodicidad: TStringGrid;
    ELargoPeriodo: TEdit;
    CBLargoPeriodo: TComboBox;
    CBRestrEMax: TCheckBox;
    ERestrEMax: TEdit;
    BAyuda: TButton;
    LIndicePreciosPorCombustible: TLabel;
    LBornePreciosPorCombustible: TLabel;
    CBFuenteIndicePreciosPorCombustible: TComboBox;
    CBBorneIndicePreciosCombustible: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure EditEnter(Sender: TObject);
    procedure BCancelarClick(Sender: TObject);
    procedure sgChequearCambios(Sender: TObject);
    procedure sgGetEditText(Sender: TObject; ACol, ARow: integer;
      var Value: string);
    procedure BGuardarClick(Sender: TObject); override;
    procedure CBPeriodicidadClick(Sender: TObject);
    procedure CBRestrEMaxClick(Sender: TObject);
    procedure BAyudaClick(Sender: TObject);
    procedure CBFuenteIndicePreciosPorCombustibleChange(Sender: TObject);
  protected
    function validarFormulario(): boolean; override;
  private
    Generador: TGTer_combinado;
  public
    constructor Create(AOwner: TComponent; cosaConNombre: TCosaConNombre;
      ficha: TFichaLPD; sala: TSalaDeJuego); override;
  end;

var
  EditarFichaGTer_combinado: TEditarFichaGTer_combinado;

implementation

uses SimSEEEditMain, uBaseAltasEditores;

{$IFNDEF FPC}
  {$R *.dfm}

{$ELSE}
  {$R *.lfm}
{$ENDIF}

constructor TEditarFichaGTer_combinado.Create(AOwner: TComponent;
  cosaConNombre: TCosaConNombre; ficha: TFichaLPD; sala: TSalaDeJuego);
var
  fichaAux: TFichaGTer_combinado;
  i: integer;
begin
  inherited Create(AOwner, cosaConNombre, ficha, sala);
  Generador := cosaConNombre as TGTer_combinado;
  guardado := True;
  inherited llenarCamposPeriodicidad(CBLargoPeriodo, ELargoPeriodo,
    EFIniPeriodo, EFFinPeriodo, sgPeriodicidad, CBPeriodicidad, ficha, PPeriodicidad);
  inherited inicializarCBFuente(CBFuenteIndicePreciosPorCombustible,
    CBBorneIndicePreciosCombustible, True);

  if (ficha <> nil) then
  begin
    fichaAux := ficha as TFichaGTer_combinado;
    self.EFIni.Text := FSimSEEEdit.fechaIniToString(fichaAux.fecha);

    //Cargo la tabla de TG con los valores de la ficha
    self.IntFichaTG.cells[1, 0] := FloatToStr(fichaAux.PMin_TG);
    self.IntFichaTG.cells[1, 1] := FloatToStr(fichaAux.PMax_TG);
    self.IntFichaTG.cells[1, 2] := FloatToStr(fichaAux.cv_min_TG);
    self.IntFichaTG.cells[1, 3] := FloatToStr(fichaAux.cv_TG);
    self.IntFichaTG.cells[1, 4] := FloatToStr(fichaAux.disp_TG);
    self.IntFichaTG.cells[1, 5] := FloatToStr(fichaAux.tRepHoras_TG);


    //Cargo la tabla de CC con los valores de la ficha
    self.IntFichaTV.cells[1, 0] := FloatToStr(fichaAux.PMin_TV);
    self.IntFichaTV.cells[1, 1] := FloatToStr(fichaAux.PMax_TV);
    self.IntFichaTV.cells[1, 2] := FloatToStr(fichaAux.cv_min_TV);
    self.IntFichaTV.cells[1, 3] := FloatToStr(fichaAux.cv_TV);
    self.IntFichaTV.cells[1, 4] := FloatToStr(fichaAux.disp_TV);
    self.IntFichaTV.cells[1, 5] := FloatToStr(fichaAux.tRepHoras_TV);

    EPotTVdivTG.Text := FloatToStr(fichaAux.factorPotenciaTVdivTG);

    inherited initCBRestriccion(fichaAux.HayRestriccionEmaxPasoDeTiempo, CBRestrEMax,
      fichaAux.EmaxPasoDeTiempo, ERestrEMax);
    inherited setCBFuente(CBFuenteIndicePreciosPorCombustible,
      CBBorneIndicePreciosCombustible, fichaAux.indicePreciosPorCombustible,
      fichaAux.bornePreciosPorCombustible);

    ePagoPorPotencia.Text:= FloatToStr( fichaAux.PagoPorDisponibilidad_USD_MWh );
    ePagoPorEnergia.Text:= FloatToStr( fichaAux.PagoPorEnergia_USD_MWh );
  end
  else
  begin
    self.EFIni.Text := '';
    for i := 0 to self.IntFichaTG.RowCount - 1 do
      self.IntFichaTG.cells[1, i] := '';
    for i := 0 to self.IntFichaTV.RowCount - 1 do
      self.IntFichaTV.cells[1, i] := '';

    inherited initCBRestriccion(False, CBRestrEMax, 0, ERestrEMax);
    ePagoPorPotencia.Text:= FloatToStr( 0.0 );
    ePagoPorEnergia.Text:= FloatToStr( 0.0 );

  end;
end;

function TEditarFichaGTer_combinado.validarFormulario(): boolean;
begin

  Result := inherited validarFormulario and validarEditFecha(EFIni) and inherited validarPeriodicidad(
    CBPeriodicidad, CBLargoPeriodo, ELargoPeriodo, EFIniPeriodo,
    EFFinPeriodo, sgPeriodicidad) and inherited validarTablaNReals_(IntFichaTG) and
    inherited validarTablaNReals_(IntFichaTV) and
    inherited validarRestriccion(CBRestrEMax, ERestrEMax, 1, MaxNReal) and
    inherited validarCBFuente(CBFuenteIndicePreciosPorCombustible,
    CBBorneIndicePreciosCombustible, 0) and validarEditFloat(EPotTVdivTG, 0, 100000)
    and validarEditFloat( ePagoPorPotencia ) and validarEditFloat( ePagoPorEnergia );
end;

procedure TEditarFichaGTer_combinado.FormCreate(Sender: TObject);
begin
  utilidades.AgregarFormatoFecha(LFIni);

  //Inicializo etiquetas de las grillas
  self.IntFichaTG.cells[0, 0] := rsPotenciaMinima;
  self.IntFichaTG.cells[0, 1] := rsPotenciaMaxima;
  self.IntFichaTG.cells[0, 2] := rsCostoVariablePotenciaMinima;
  self.IntFichaTG.cells[0, 3] := rsCostoVariable;
  self.IntFichaTG.cells[0, 4] := rsCoeficienteDisponibilidadFortuita;
  self.IntFichaTG.cells[0, 5] := rsTiempoDeReparacionH;


  self.IntFichaTV.cells[0, 0] := rsPotenciaMinima;
  self.IntFichaTV.cells[0, 1] := rsPotenciaMaxima;
  self.IntFichaTV.cells[0, 2] := rsCostoVariablePotenciaMinima;
  self.IntFichaTV.cells[0, 3] := rsCostoVariable;
  self.IntFichaTV.cells[0, 4] := rsCoeficienteDisponibilidadFortuita;
  self.IntFichaTV.cells[0, 5] := rsTiempoDeReparacionH;


  utilidades.AutoSizeCol(IntFichaTG, 0);
  utilidades.AutosizeTable(self, IntFichaTG, maxAnchoTablaEnorme,
    maxAlturaTablaMediana, TSimSEEEditOptions.getInstance.
    deshabilitarScrollHorizontalEnListados);

  utilidades.AutoSizeCol(IntFichaTV, 0);
  utilidades.AutosizeTable(self, IntFichaTV, maxAnchoTablaEnorme,
    maxAlturaTablaMediana, TSimSEEEditOptions.getInstance.
    deshabilitarScrollHorizontalEnListados);
end;

procedure TEditarFichaGTer_combinado.FormCloseQuery(Sender: TObject;
  var CanClose: boolean);
begin
  inherited FormCloseQuery(Sender, CanClose);
end;

procedure TEditarFichaGTer_combinado.EditEnter(Sender: TObject);
begin
  inherited EditEnter(Sender);
end;

procedure TEditarFichaGTer_combinado.BCancelarClick(Sender: TObject);
begin
  inherited BCancelarClick(Sender);
end;

procedure TEditarFichaGTer_combinado.sgChequearCambios(Sender: TObject);
begin

end;

procedure TEditarFichaGTer_combinado.sgGetEditText(Sender: TObject;
  ACol, ARow: integer; var Value: string);
begin
  inherited sgGetEditText(Sender, ACol, ARow, Value);
end;

procedure TEditarFichaGTer_combinado.BGuardarClick(Sender: TObject);
var
  periodicidad: TPeriodicidad;
  restrEmax: NReal;
begin
  if validarFormulario then
  begin
  {  fAux := TFichaGenSencillo(Generador.lpd.ficha(StrToInt(self.IntAnio.text), StrToInt(self.IntSemana.text)));
  if (fAux = NIL) or (fAux = ficha2) then
     begin          }
    if not CBPeriodicidad.Checked then
      periodicidad := nil
    else
      periodicidad := inherited darPeriodicidad(CBLargoPeriodo,
        ELargoPeriodo, EFIniPeriodo, EFFinPeriodo, sgPeriodicidad);

    restrEMax := inherited rest(CBRestrEMax, ERestrEMax, MaxNReal);

    ficha := TFichaGTer_combinado.Create(
      capa,
      FSimSEEEdit.StringToFecha(EFIni.Text), periodicidad,

      //Valores de TG
      StrToFloat(self.IntFichaTG.cells[1, 0]),
      StrToFloat(self.IntFichaTG.cells[1, 1]),
      StrToFloat(self.IntFichaTG.cells[1, 2]),
      StrToFloat(self.IntFichaTG.cells[1, 3]),
      StrToFloat(self.IntFichaTG.cells[1, 4]),
      StrToFloat(self.IntFichaTG.Cells[1, 5]),

      StrToFloat(self.IntFichaTV.cells[1, 4]),
      StrToFloat(self.IntFichaTV.Cells[1, 5]),

      //Valores de CC
      StrToFloat(self.IntFichaTV.cells[1, 0]),
      StrToFloat(self.IntFichaTV.cells[1, 1]),
      StrToFloat(self.IntFichaTV.cells[1, 2]),
      StrToFloat(self.IntFichaTV.cells[1, 3]), StrToFloat(EPotTVdivTG.Text),
      valorCBFuente(CBFuenteIndicePreciosPorCombustible), valorCBString(
      CBBorneIndicePreciosCombustible), CBRestrEMax.Checked, restrEmax,
      StrToFloat( ePagoPorPotencia.text ), strToFloat( ePagoPorEnergia.text ));
    ModalResult := mrOk;
   {     end
  else
       begin
       ShowMessage(mesYaExisteFichaEnFecha);
       end     }
  end;
end;

procedure TEditarFichaGTer_combinado.CBPeriodicidadClick(Sender: TObject);
begin
  inherited switchPanelPeriodicidad(CBPeriodicidad, PPeriodicidad);
end;

procedure TEditarFichaGTer_combinado.CBFuenteIndicePreciosPorCombustibleChange(
  Sender: TObject);
begin
  inherited cbFuenteChange(CBFuenteIndicePreciosPorCombustible,
    CBBorneIndicePreciosCombustible);
end;

procedure TEditarFichaGTer_combinado.CBRestrEMaxClick(Sender: TObject);
begin
  inherited CBRestrClick(CBRestrEMax, ERestrEMax);
end;

procedure TEditarFichaGTer_combinado.BAyudaClick(Sender: TObject);
begin
  verdoc(Self, TGTer_combinado);
end;

end.
