unit unino34A0;

{$mode delphi}

interface

uses
  Classes, SysUtils, uRobotHttpPost, xMatDefs, ufechas;


type
  TN34Info  = class
    AnioIni, MesIni: integer;
    N34: TDAOfNreal;
    Pronostico: TDAOfNReal;
    constructor Create( AnioIni, MesIni: integer );
    procedure free;
  end;

implementation



const
//  valores promedios mensuales del N34
  N34ve: array[1..12] of NReal =  ( 26.57, 26.72, 27.22, 27.78,	27.85, 27.65,
                  27.22, 26.82, 26.72, 26.69,	26.65, 26.57 );

url_indices_mensuales = 'www.cpc.ncep.noaa.gov/data/indices/sstoi.indices';
url_indices_semanales = 'www.cpc.ncep.noaa.gov/data/indices/wksst8110.for';
url_pronostico = 'iri.columbia.edu/our-expertise/climate/forecasts/enso/current/';

(*
<tr>
<th>Average, all models</th>
<th>0.5</th>
<th>0.6</th>
<th>0.7</th>
<th>0.8</th>
<th>0.8</th>
<th>0.8</th>
<th>0.8</th>
<th>0.7</th>
<th>0.6</th>
</tr>
  *)

function nextpal( var r : string; sep: string = ' ' ): string;
var
  i: integer;
  res: string;
begin
  r:= trim( r );
  i:= pos( ' ', r );
  if i > 0 then
  begin
    res:= copy( r, 1, i-1 );
    delete( r, 1, i );
  end
  else
  begin
    res:= r;
    r:= '';
  end;
  result:= res;
end;

constructor TN34Info.Create( AnioIni, MesIni: integer );
var
  rbt: TRobotHttpPost;
  res: TStringList;
  k: integer;
  anio, mes: integer;
  nino12, anom12, nino3, anom3, nino4, anom4, nino34, anom34: NReal;
  r: string;


begin
  inherited Create;

  self.AnioIni:= AnioIni;
  self.MesIni:= MesIni;

  rbt:= TRobotHttpPost.Create( url_indices_mensuales, '', '');
  res:= rbt.post( 'GET' );

  for k:= 1 to res.count-1 do
  begin
    r:= res[k];
    anio:=StrToInt( nextpal( r ) );
    mes:= StrToInt( nextpal( r ) );
    nino12:= StrToFloat( nextpal( r ) );
    anom12:= StrToFloat( nextpal( r ) );
    nino3:= StrToFloat( nextpal( r ));
    anom3:= StrToFloat( nextpal( r ));
    nino4:= StrToFloat( nextpal( r ) );
    anom4:= StrTofloat( nextpal( r ) );
    nino34:= StrToFloat( nextpal( r ));
    anom34:= StrToFloat( nextpal( r ));

    writeln( k:4, ', ', Anio,', ', Mes, ', ',Nino34:12:2, ', ', Anom34: 12:2 );

  end;


  (*
  N34: TDAOfNreal;
  Pronostico: TDAOfNReal;
    *)
  rbt.Free;


end;


procedure TN34Info.free;
begin
  setlength( N34, 0 );
  setlength( Pronostico, 0 );
  inherited Free;
end;



end.

